#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=KF64.ico
#AutoIt3Wrapper_Compression=4
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <File.au3>


#region ;Gui

Global $Size = 16
Global $drive, $folder, $file, $extension
Global $ISO_Location = ""


GUICreate("KF Tool v2", 260, 165)

;Tab1
GUICtrlCreateTab(1, 1, 259, 164)
$L = 10
$T = 30
$W = 80
$H = 25
GUICtrlCreateTabItem("Texture Extractor")
$ExtractorProgressLabel = GUICtrlCreateLabel("....", $L, $T, 200, $H)
$OpenFileButton = GUICtrlCreateButton("Scan File", $L, $T + $H + 5, $W, $H)
GUICtrlSetTip(-1, "Scan a KF game file and extract images as TIMs")
$InsertTIMButton = GUICtrlCreateButton("Insert TIM", $L + $W + 10, -1, $W, $H)
GUICtrlSetTip(-1, "Select a TIM to reinsert in a KF game file")

;Tab2
GUICtrlCreateTabItem("Enable Edits")

$L = 10
$T = 25
$W = 80
$H = 20

$Label = GUICtrlCreateLabel(". . .", $L, $T, 240, $H)

$SelectBINButton = GUICtrlCreateButton("Select BIN", $L, $T + $H + 3, $W, $H)
GUICtrlSetTip(-1, "Select a BIN or IMG type CD image modify")
$Go = GUICtrlCreateButton("Go", $L + 150, -1, $W, $H)

$T = $T + 65
$W = 80
GUICtrlCreateGroup("Text-Image Editing", $L - 5, $T - 17, 250, $H + 20)
$Enable = GUICtrlCreateRadio("Enable", $L, $T, $W, $H)
GUICtrlSetTip(-1, "Modify BIN to allow Text graphic editing")
GUICtrlSetState(-1, $GUI_CHECKED)
$disableButton = GUICtrlCreateRadio('Disable', $L + 100, $T, $W, $H)
GUICtrlSetTip(-1, "Reset BIN back to normal (Editing disallowed)")

$T = $T + 45
$W = 70
GUICtrlCreateGroup("Select BIN type", $L - 5, $T - 17, 250, $H + 20)
$KF1Radio = GUICtrlCreateRadio("KF1(US)", $L, $T, $W, $H)
GUICtrlSetState(-1, $GUI_CHECKED)
$KF2Radio = GUICtrlCreateRadio("KF2(US)", $L + 85, $T, $W, $H)
$KFEuRadio = GUICtrlCreateRadio("KF(EU)", $L + 170, $T, $W, $H)


GUICtrlCreateTabItem("")

GUISetState(@SW_SHOW)
#endregion ;Gui



While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit


			;#################### IMAGE EXTRACTOR ################################
		Case $OpenFileButton
			$FileLocation = FileOpenDialog("Select file with graphics", @WorkingDir, "(*.*)")
			If @error Then

			Else
				_PathSplit($FileLocation, $drive, $folder, $file, $extension)

				GUICtrlSetData($ExtractorProgressLabel, $file & $extension & " Scanning File...")

				$num = 1

				;open File to scan
				$input = FileOpen($FileLocation, 16)


				;Read file into array of 4byte chunks
				Local $array[(FileGetSize($FileLocation) / 4) + 1]
				$array[0] = UBound($array)
				For $i = 1 To $array[0] - 1
					$array[$i] = FileRead($input, 4)
				Next

				;Scan for image tags
				For $i = 1 To $array[0] - 1

					;If first header tag is found
					If $array[$i] = Binary("0x10000100") And $array[$i + 2] = Binary("0x10000100") Then

						;If second header test passes
						If $array[$i - 1] = $array[$i + 1] Then

							;get image start location
							$imageLocation = GetImageLocation($i)

							;read palette
							FileSetPos($input, $imageLocation - 0x30, 0)
							$Palette = FileRead($input, 0x20)

							;get image size
							FileSetPos($input, 0xE, 1)
							$Size = Number(FileRead($input, 2))

							;read image
							$image = FileRead($input, ($Size * .5) * $Size)

							;update progress label
							GUICtrlSetData($ExtractorProgressLabel, $file & $extension & "  Found: " & $num)
							$num = $num + 1

							;Write TIM
							$output = FileOpen(@WorkingDir & "\" & $file & $extension & " 0x" & Hex($imageLocation, 6) & ".tim", 18)
							FileWrite($output, MakeTIMHeader($Palette) & $image)
							FileClose($output)

						EndIf
					EndIf
				Next
				FileClose($input)
				MsgBox(0, "", "Done", .5)
			EndIf



		Case $InsertTIMButton
			$FileLocation = FileOpenDialog("Select file to insert", @WorkingDir, "(*.tim)")
			If @error Then
			Else
				;open TIM
				$input = FileOpen($FileLocation, 16)

				_PathSplit($FileLocation, $drive, $folder, $file, $extension)

				;read input palette and Image
				FileSetPos($input, 0x14, 0)
				$Palette = FileRead($input, 0x20)
				FileSetPos($input, 0xC, 1)
				$image = FileRead($input)

				;get insert-file name from TIM name
				$outfile = StringLeft($file, StringLen($file) - 9)

				;get where to insert file from TIM name
				$imageLocation = StringRight($file, 8)

				;check if insert-file exists
				If FileExists($drive & $folder & $outfile) = True Then
					$output = FileOpen($drive & $folder & $outfile, 17)
				Else
					$outfile = FileOpenDialog("Insert Image into which file?", @WorkingDir, "(*.*)")
					$output = FileOpen($outfile)
				EndIf


				;insert Palette
				FileSetPos($output, $imageLocation - 0x30, 0)
				FileWrite($output, $Palette)

				;insert image
				FileSetPos($output, 0x10, 1)
				FileWrite($output, $image)

				;Update progress Label
				GUICtrlSetData($ExtractorProgressLabel, "Insert: " & $file)
				FileClose($output)
				FileClose($input)

				MsgBox(0, "", "Done", .5)

			EndIf
			;#################### END IMAGE EXTRACTOR ################################




			;#################### EDIT ENABLER #######################################

		Case $SelectBINButton
			Local $Temp = FileOpenDialog("Select Brigandine Grand Disk Image", @WorkingDir, "(*.bin)(*.img)", 1)
			If @error Then

			Else
				$ISO_Location = $Temp
				GUICtrlSetData($Label, GetFileName($ISO_Location))
			EndIf

		Case $Go
			If $ISO_Location = "" Then ; if no ISO is loaded
				MsgBox(0, "Whoops!", "Please select the disk image to tweak.")

			ElseIf FileExists($ISO_Location) = True Then

				$ISO = FileOpen($ISO_Location, 17)

				;set position
				If GUICtrlRead($KF1Radio) = $GUI_CHECKED Then
					FileSetPos($ISO, 0x553f0, 0)
				ElseIf GUICtrlRead($KF2Radio) = $GUI_CHECKED Then
					FileSetPos($ISO, 0x591f0, 0)
				Else ;if Eu
					FileSetPos($ISO, 0x57f08, 0)
				EndIf


				;reads op code
				$Temp = Binary(FileRead($ISO, 4))

				;if "enable" is checked
				If GUICtrlRead($Enable) = $GUI_CHECKED Then

					;if patch already applied
					If $Temp = "0x00000000" Then
						MsgBox(0, "Whoops!", 'It appears the image is already set to "Enable editing"')

						;apply patch
					ElseIf $Temp = "0xF9FF4014" Then
						FileSetPos($ISO, -4, 1)
						FileWrite($ISO, Binary("0x00000000"))
						MsgBox(0, "Done", 'Editing is enabled')

						;If data does not match 'enabled' or 'disabled' value
					Else
						MsgBox(0, "Whoops!", 'Unknown Image')
					EndIf

					;if "disable" is checked
				Else

					;if ISO already normal
					If $Temp = "0xF9FF4014" Then
						MsgBox(0, "Whoops!", 'It appears the image is already "un-tweaked"')

						;remove patch
					ElseIf $Temp = "0x00000000" Then
						FileSetPos($ISO, -4, 1)
						FileWrite($ISO, Binary("0xF9FF4014"))
						MsgBox(0, "Done", 'Disk image returned to normal')

						;If data does not match 'enabled' or 'disabled' value
					Else
						MsgBox(0, "Whoops!", 'Unknown Image')
					EndIf
				EndIf
				FileClose($ISO)
			EndIf

			;#################### END EDIT ENABLER #######################################

















	EndSwitch
WEnd














Func GetImageLocation($x)
	;$x is number of 4-byte chunks so far
	$x = ($x * 4) + 56
	Return ($x)
EndFunc   ;==>GetImageLocation




Func MakeTIMHeader($p)
	If $Size = 16 Then
		$is = Binary(0x8c)
		$ih = Binary("0x1000")
		$iw = Binary("0x0400")
	ElseIf $Size = 32 Then
		$is = Binary(0x20c)
		$ih = Binary("0x2000")
		$iw = Binary("0x0800")
	ElseIf $Size = 64 Then
		$is = Binary(0x80c)
		$ih = Binary("0x4000")
		$iw = Binary("0x1000")
	ElseIf $Size = 128 Then
		$is = Binary(0x200c)
		$ih = Binary("0x8000")
		$iw = Binary("0x2000")
	ElseIf $Size = 256 Then
		$is = Binary(0x800c)
		$ih = Binary("0x0001")
		$iw = Binary("0x4000")
	Else ;if is odd shape
		$is = Binary(0x0000)
		$ih = Binary("0x0000")
		$iw = Binary("0x0000")
	EndIf

	$H = Binary("0x10000000080000002C0000000000000010000100") & _
			Binary($p) & _
			Binary($is) & _  ;Image size +0x0c 4bytes
			Binary(0x0) & _ ;frame buffer 4bytes
			Binary($iw & $ih) ;Image width/4 and height 4bytes total
	Return ($H)

EndFunc   ;==>MakeTIMHeader



Func GetFileName($x)
	;x = full file address
	;returns file name+extension only
	Local $y = StringSplit($x, "\")
	Local $z = $y[$y[0]]
	Return $z
EndFunc   ;==>GetFileName